/* 24. Oktober 2018 */

#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

#include "Mapping_Register_BCM2835.h"
#include "Mapping_Register_GPIO.h"

#define BLOCK_SIZE        1024

unsigned long*         Pointer_Register_Gpio = NULL;
static const  __off_t  Offset_Addr_Gpio      = 0x200000;
static int             fd                    = -1;

size_t Mapping_Register_GPIO(void)
{
   size_t   error;
   __off_t  Base_Address_Gpio;

   error = (size_t)(-1);

   if((fd = open("/dev/mem", O_RDWR | O_SYNC | O_CLOEXEC)) < 0) {
      printf("%s\r\n", "Unable to open /dev/mem");
      goto END_Mapping_Register_GPIO;
   }

   Base_Address_Gpio     = BASE_ADDR_PERIPH + Offset_Addr_Gpio;
   Pointer_Register_Gpio = mmap(NULL, BLOCK_SIZE, PROT_READ|PROT_WRITE, MAP_SHARED, fd, Base_Address_Gpio);
   if((long)Pointer_Register_Gpio == -1) {
      printf("%s", "Init: mmap(gpio) failed\r\n");
      goto END_Mapping_Register_GPIO;
   }

   error = 0;

END_Mapping_Register_GPIO:
   if(fd != -1) {
      close(fd);
      fd = -1;
   }

   return  error;
}
