/* 24. Oktober 2018 */

#include  <stddef.h>
#include  <math.h>
#include  <stdio.h>

#include  "Mapping_Register_GPIO.h"
#include  "gpio.h"

#define INPUT_A  17        // Pin 11
#define OUTPUT_B 27        // Pin 13

int main(void)
{
   unsigned int state;
   unsigned int state_before;

   Mapping_Register_GPIO();                           // Setzt die Zeiger "Pointer_Register_Gpio" fuer Zugriff auf BCM2835
   init_gpio();                                       // Zugriff auf GPIOs initialisieren

   gpio_pin_function(INPUT_A, FSEL_INPT, PULL_DOWN);  // GPIO Pin 11 als Eingang (Schalter von +3,3V zum Pin bzw. für PNP-Open-Collector)
   gpio_pin_function(OUTPUT_B, FSEL_OUTP, 0);         // GPIO Pin 13 als Ausgang

   state_before = (unsigned)~0;

   while(1) {
      gpio_pin_in_state(INPUT_A, &state);             // gpio_INPUT_A lesen
      if(state_before == state) {                     // Status hat sich geändert ?
         continue;                                    // nein
      }

      gpio_pin_out_state(OUTPUT_B, state);            // Status nach gpio_OUTPUT_B schreiben;
      printf("%s\n", state ? "EIN" : "AUS");          // aktuellen Eingangszustand ausgeben
      state_before = state;
   }

   return -1;
}