/* 24. Oktober 2018 */

#include <stddef.h>

#include  "Mapping_Register_GPIO.h"
#include  "gpio.h"

volatile static char    Txt[] = "SDG";

size_t  init_gpio(void)
{
   size_t        error;

   error = (size_t)(-1);

   if(Pointer_Register_Gpio == NULL) {
      goto END_init_gpio;
   }

   *(Pointer_Register_Gpio + 0) = 0;  // Pins  0 ..  9 auf Input
   *(Pointer_Register_Gpio + 1) = 0;  // Pins 10 .. 19 auf Input
   *(Pointer_Register_Gpio + 2) = 0;  // Pins 20 .. 29 auf Input
// *(Pointer_Register_Gpio + 3) = 0;  // belegt vom Betriebssystem
// *(Pointer_Register_Gpio + 4) = 0;  // belegt vom Betriebssystem
// *(Pointer_Register_Gpio + 5) = 0;  // belegt vom Betriebssystem

   error = 0;

END_init_gpio:
   return   error;
}

size_t  gpio_pin_function(unsigned int pin, unsigned int  mode, size_t pull_mode)
{
   unsigned long*  pointer;
   unsigned long   pattern;
   unsigned int    register_offset;
   unsigned int    pattern_offset;
   unsigned long   register_pattern;
   size_t          wait;
   size_t          error;

   error = (size_t)(-1);

   if(!(pin < 30)) {
      goto END_gpio_pin_function;
   }

   if(mode > 0b111) {
      goto END_gpio_pin_function;
   }

   register_offset    = pin / 10;
   pattern_offset     = pin - register_offset * 10L;
   register_pattern   = mode <<(pattern_offset * 3);

   pointer  = Pointer_Register_Gpio + register_offset;
   pattern  = *pointer;
   pattern &= ~register_pattern;
   pattern |=  register_pattern;
   *pointer = pattern;

   error = 0;

   if(mode == FSEL_INPT) {
      *((unsigned long*)((char*)Pointer_Register_Gpio+GPPUD)) = pull_mode;
   }
   else {
      *((unsigned long*)((char*)Pointer_Register_Gpio+GPPUD)) = 0;
   }

   wait = 150;       // 150 mindestens Zyklen warten
   while(wait--);

   pattern = (unsigned)1L << pin;
   *((unsigned long*)((char*)Pointer_Register_Gpio+GPPUDCLK0)) = pattern; // aktivieren

   wait = 150;       // 150 mindestens Zyklen warten
   while(wait--);

   *((unsigned long*)((char*)Pointer_Register_Gpio+GPPUD))     = 0;
   *((unsigned long*)((char*)Pointer_Register_Gpio+GPPUDCLK0)) = 0;

END_gpio_pin_function:
   return error;
}

size_t  gpio_pin_out_state(unsigned int pin, unsigned int state)
{
   size_t                   error;
   register unsigned long*  p_map;
   register unsigned long   pattern;

   error = (size_t)(-1);
   pattern = 0;

   if(!(pin < 30)) {
      goto END_gpio_pin_out_state;
   }

   pattern = (unsigned long)1 << pin;
   if(state == 0) {
      p_map = (unsigned long*)((char*)Pointer_Register_Gpio + 0x28);  // p_map = GPCLR0
   }
   else {
      p_map = (unsigned long*)((char*)Pointer_Register_Gpio + 0x1C);  // p_map = GPSET0
   }
   *p_map = pattern;

   error = 0;

END_gpio_pin_out_state:
   return error;
}

size_t  gpio_pin_in_state(unsigned int pin, unsigned int* state)
{
   size_t                   error;
   register unsigned long*  p_map;
   register unsigned long   pattern;

   error = (size_t)(-1);

   if(!(pin < 30)) {                     // GPIOs über 29 sind schon belegt
      goto END_gpio_pin_in_state;
   }

   pattern = (unsigned long)1 << pin;
   p_map = (unsigned long*)((char*)Pointer_Register_Gpio + 0x34);  // p_map = GPLEV0

   *state = *p_map & pattern ? 1 : 0;

   error = 0;

END_gpio_pin_in_state:
   return error;
}

